package org.greenstone.gatherer.gui.messages;
/**
 *#########################################################################
 *
 * A component of the Gatherer application, part of the Greenstone digital
 * library suite from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * <BR><BR>
 *
 * Author: John Thompson, Greenstone Digital Library, University of Waikato
 *
 * <BR><BR>
 *
 * Copyright (C) 1999 New Zealand Digital Library Project
 *
 * <BR><BR>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * <BR><BR>
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * <BR><BR>
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *########################################################################
 */
import java.awt.*;
import java.util.StringTokenizer;
import javax.swing.*;
import org.greenstone.gatherer.Gatherer;
/**
 * @author John Thompson, Greenstone Digital Library, University of Waikato
 * @version 1.1
 */
class MessageListRenderer 
    extends JLabel 
    implements ListCellRenderer {

    // Constructor
    public MessageListRenderer() {
    }
    // This is the only method defined by ListCellRenderer.
    // We just reconfigure the JLabel each time we're called.
    public Component getListCellRendererComponent(
						  JList list,
						  Object value,            // value to display
						  int index,               // cell index
						  boolean isSelected,      // is the cell selected
						  boolean cellHasFocus) {  // the list and the cell have the focus
	// Get the message
	String s = value.toString();
	setText(s);
	// Now parse out the level
	StringTokenizer tokenizer = new StringTokenizer(s);
	// Throw away source.
	tokenizer.nextToken();
	// Now add color details based on level
	String level = tokenizer.nextToken();
	if(level.equals(get("Main"))) {
	    setForeground(Color.black);
	} else if (level.equals(get("Event"))) {
	    setForeground(Color.blue);
	} else if (level.equals(get("Information"))) {
	    setForeground(Color.gray);
	} else {
	    setForeground(Color.red);
	}
	setEnabled(list.isEnabled());
	setFont(list.getFont());
	return this;
    }

    private String get(String key) {
	if(key.indexOf('.') == -1) {
	    key = "Level." + key;
	}
	return Gatherer.dictionary.get(key);
    }
}
