package org.greenstone.gsdl3.core;

import org.greenstone.gsdl3.util.*;
import org.greenstone.gsdl3.action.*;
// XML classes
import org.w3c.dom.Node; 
import org.w3c.dom.NodeList; 
import org.w3c.dom.Document; 
import org.w3c.dom.Element; 

// other java classes
import java.io.File;
import java.util.HashMap;
import java.util.Enumeration;

/** The default greenstone receptionist - needs some extra info for each page
 * @see WebReceptionist
 */
public class DefaultReceptionist extends WebReceptionist {
    
    protected void addExtraInfo(Element page) {
	// we want to add in the collection description for each page - cos
	// our default xslt needs this.
	super.addExtraInfo(page);
	
	Element page_request = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_REQUEST_ELEM);
	System.out.println("add extra info, page request="+this.converter.getString(page_request));
	// is a collection defined?
	Element param_list = (Element)GSXML.getChildByTagName(page_request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
	if (param_list==null) { // must be the original home page
	    return;
	}
	Element coll_param = GSXML.getNamedElement(param_list, GSXML.PARAM_ELEM, GSXML.NAME_ATT, this.cgi.COLLECTION_ARG);
	if (coll_param == null) {
	    return;
	}
	String action = page_request.getAttribute(GSXML.ACTION_ATT);
	if (action.equals("p")) {
	    return;
	}
	// we have a collection, and we are not page action. get the coll description
	
	String collection = coll_param.getAttribute(GSXML.VALUE_ATT);
	String lang = page_request.getAttribute(GSXML.LANG_ATT);
	Element coll_about_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
	Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE,  collection, lang);
	coll_about_message.appendChild(coll_about_request);
	
	Element coll_about_response_message = this.mr.process(coll_about_message);
	Element coll_about_response = (Element)GSXML.getChildByTagName(coll_about_response_message, GSXML.RESPONSE_ELEM);
	Element coll_description = (Element)GSXML.getChildByTagName(coll_about_response, GSXML.COLLECTION_ELEM);
	if (coll_description==null) { // may be a cluster
	    coll_description = (Element)GSXML.getChildByTagName(coll_about_response, GSXML.CLUSTER_ELEM);
	}
	if (coll_description != null) {
	    Element page_response = (Element)GSXML.getChildByTagName(page, GSXML.PAGE_RESPONSE_ELEM);
	    page_response.appendChild(this.doc.importNode(coll_description, true));
	}
    }
}

